/** datatable : a datatable represents raw data.*/

// A column metadata object.
function datatablecolumn(datatable, column_name)
{
  
  this.column_name = column_name;
  this.data = new Array();

  if (datatable) 
  {
    this.datatable = datatable;
    datatable.columns.push(this);
  }
  
}

function datatable_propagate(datatable, action, row_idx, col_idx)
{

	var obj_idx;
	for (obj_idx in datatable.dataviews)
	{
		dataview_data_event(datatable.dataviews[obj_idx], action, row_idx, col_idx);
	}
}

function datatable_populate_from_csv(datatable,srcdata, rowsep, colsep)
{

	// Split rows using separator in rowsep.
	var rows = srcdata.split(rowsep);
	// Base on first column
	var cols = rows[0].split(colsep);
	var col_idx, curr_column;
	var data_length = rows.length;
	for (col_idx in cols) // Currently, the datatable expects the first row to have headings and reads them here.
	{
		curr_column = new datatablecolumn(datatable, cols[col_idx], 80); 
		curr_column.data.length = rows.length -1;
	}
	// Iterate through rows
	if (data_length > 1)
	{
		var row_idx;
		for (row_idx=1;row_idx<data_length;row_idx++)
		{
	    // Iterate through columns.
			cols = rows[row_idx].split(colsep);
			for (col_idx in cols)
			{
				if (col_idx > datatable.columns.length-1) // Check data width
				{
					alert("Data has more columns than heading("+datatable.columns.length +") on row "+ row_idx + ". \nCheck format and column separator settings.\n Column index : " + col_idx + ". Data \"" + cols[col_idx] +". \n"+ rows[row_idx]);
				}
				else
				{
					datatable.columns[col_idx].data[row_idx - 1] = cols[col_idx];
				}
			}
		}
	}
	  
	if (rows[row_idx]) 
	{
		datatable.count = data_length - 1; // Exempt header.
	}
	else
		{
		datatable.count = data_length - 2; // The last row ended with a row break, .split doesn't get that..
	}
	datatable.refresh;
}

function datatable_populate_from_csv_URL(datatable,srcURL, rowsep, colsep)
{
	var data = MakeRequest(srcURL);
	datatable_populate_from_csv(datatable,data, rowsep, colsep);
}

function datatable_insertat(datatable, row_idx)
{
  var col_idx;
  for (col_idx in datatable.columns)
  {
    datatable.columns[col_idx].data.splice(row_idx,0, ""); // ?
  }
  datatable.count++;
}

function datatable_removeat(datatable, row_idx)
{
  var col_idx;
  for (col_idx in datatable.columns)
  {
    datatable.columns[col_idx].data.splice(row_idx,1); // ?
  }
  datatable.count--;
}

function datatable(datatable_name)
{
  // Fields
  this.count = 0;
  this.name = name;
  this.columns = new Array();
  this.dataviews = new Array();

  this.populate_from_csv_string = function populate_from_csv_string(srcdata, rowsep, colsep) {datatable_populate_from_csv(this,srcdata,rowsep,colsep);} 
  this.populate_from_csv_URL = function populate_from_csv_URL(srcURL, rowsep, colsep) {datatable_populate_from_csv_URL(this,srcURL,rowsep,colsep);} 
  // Functions
  this.refresh = function refresh() {datatable_propagate(this, "refresh"); } 

  this.removeat = function removeat(row_idx) {datatable_removeat(this, row_idx);datatable_propagate(this, "remove", row_idx);}
  this.insertat = function insertat(row_idx) {datatable_insertat(this, row_idx);datatable_propagate(this, "insert", row_idx);}
  
//  this.next = function next() { curr_row++; propagate(this, "next");}
//  this.previous = function previous() { curr_row--; propagate(this, "previous");}
//  this.first = function next() { curr_row = 0; propagate(this, "first");}
//  this.previous = function previous() { curr_row = count; propagate(this, "previous");}

}